bootcamp/news/urls.py
from django.conf.urls import url

from bootcamp.news import views

app_name = 'news'
urlpatterns = [
    url(r'^$', views.NewsListView.as_view(), name='list'),
    url(r'^delete/(?P<pk>[-\w]+)/$',
        views.NewsDeleteView.as_view(), name='delete_news'),
    url(r'^post-news/$', views.post_news, name='post_news'),
    url(r'^like/$', views.like, name='like_post'),
    url(r'^get-thread/$', views.get_thread, name='get_thread'),
    url(r'^post-comment/$', views.post_comment, name='post_comments'),
    url(r'^update-interactions/$', views.update_interactions, name='update_interactions'),
]

bootcamp/qa/urls.py
from django.conf.urls import url

from bootcamp.qa import views

app_name = 'qa'
urlpatterns = [
    url(r'^quizes/$', views.LoadQuizes.as_view(), name='quizes'),
    url(r'^quizes/(?P<slug>[\w-]+)/$', views.LoadQuiz.as_view(), name='quiz'),
    url(r'^activity/$', views.SaveActivity.as_view(), name='save_activity'),
    url(r'^vcourse/$', views.LoadVocabularyCourses.as_view(), name='vocabulary_courses'),
    url(r'^vbookmark/$', views.LoadVocabularyBookmarked.as_view(), name='vocabulary_bookmarked'),
    url(r'^vbookmark/(?P<id>\d+)/$', views.SaveVocabularyBookmark.as_view(), name='vocabulary_save_bookmark'),
    url(r'^vcourse/(?P<id>\d+)/$', views.LoadVocabularyCourse.as_view(), name='vocabulary_course'),
    url(r'^vprogress/$', views.SaveVocabularyProgress.as_view(), name='save_vocabulary_progress'),
]

bootcamp/users/urls.py
from django.conf.urls import url
from django.views.generic import TemplateView

from bootcamp.users import views

app_name = 'users'
urlpatterns = [
    url(
        regex=r'^$',
        view=views.UserListView.as_view(),
        name='list'
    ),
    url(
        regex=r'^~redirect/$',
        view=views.UserRedirectView.as_view(),
        name='redirect'
    ),
    url(
        regex=r'^~update/$',
        view=views.UserUpdate.as_view(),
        name='update'
    ),
    url(
        regex=r'^~validate/$',
        view=views.UserValidationView.as_view(),
        name='validate'
    ),
    url(
        regex=r'^(?P<username>[\w+]+)/$',
        view=views.UserDetailView.as_view(),
        name='detail'
    ),
    url(
        regex=r'^~upload/(?P<filename>[\w-]+)/$',
        view=views.ImageUploadView.as_view(),
        name='upload'
    ),
    url(
        regex=r'^~proof/(?P<filename>[\w-]+)/$',
        view=views.ProofUploadView.as_view(),
        name='proof'
    ),
    url(
        regex=r'^~remove/$',
        view=views.ImageDeleteView.as_view(),
        name='remove'
    ),
    url(
        regex=r'^~reorder/$',
        view=views.ImageReorderView.as_view(),
        name='reorder'
    ),
    url(
        regex=r'^~login/$',
        view=views.GoogleSignInView.as_view(),
        name='google_sign_in'
    ),
    url(
        regex=r'^~logout/$',
        view=views.FCMLogoutView.as_view(),
        name='fcm_logout'
    ),
    url(
        regex=r'^~logoutall/$',
        view=views.FCMLogoutAllView.as_view(),
        name='fcm_logoutall'
    ),
    url(
        regex=r'^~location/$',
        view=views.UpdateLocationView.as_view(),
        name='update_location'
    ),
    url(
        regex=r'^~fcmtoken/$',
        view=views.RegistrationToken.as_view(),
        name='token-detail'
    ),
]

config/urls.py
from django.conf import settings
from django.conf.urls import include, url
from django.conf.urls.static import static
from django.contrib import admin
from django.views.generic import TemplateView
from django.views import defaults as default_views

from graphene_django.views import GraphQLView

urlpatterns = [
    url(r'^$',
        TemplateView.as_view(template_name='pages/empty_landing.html'), name='home'),
    url(r'^~privacy-policy/$',
        TemplateView.as_view(template_name='pages/privacy.html'), name='about'),
    # Django Admin, use {% url 'admin:index' %}
    url(settings.ADMIN_URL, admin.site.urls),
    # User management
    url(r'^users/', include('bootcamp.users.urls', namespace='users')),
    url(r'^accounts/', include('allauth.urls')),
    # Third party apps here
    url(r'^comments/', include('django_comments.urls')),
    url(r'^graphql', GraphQLView.as_view(graphiql=True)),
    url(r'^markdownx/', include('markdownx.urls')),
    # Local apps here
    url(r'^notifications/',
        include('bootcamp.notifications.urls', namespace='notifications')),
    url(r'^articles/',
        include('bootcamp.articles.urls', namespace='articles')),
    url(r'^news/', include('bootcamp.news.urls', namespace='news')),
    url(r'^friendships/',
        include('bootcamp.friendships.urls', namespace='friendships')),
    url(r'^messages/',
        include('bootcamp.messager.urls', namespace='messager')),
    url(r'^qa/', include('bootcamp.qa.urls', namespace='qa')),
    url(r'^search/', include('bootcamp.search.urls', namespace='search')),
    url(r'^auth/', include('knox.urls')),
    url(r'^shop/', include('shop.urls')),

] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG:
    # This allows the error pages to be debugged during development
    urlpatterns += [
        url(r'^400/$', default_views.bad_request, kwargs={'exception': Exception('Bad Request!')}),
        url(r'^403/$', default_views.permission_denied, kwargs={'exception': Exception('Permission Denied')}),
        url(r'^404/$', default_views.page_not_found, kwargs={'exception': Exception('Page not Found')}),
        url(r'^500/$', default_views.server_error),
    ]
    if 'debug_toolbar' in settings.INSTALLED_APPS:
        import debug_toolbar
        urlpatterns = [
            url(r'^__debug__/', include(debug_toolbar.urls)),
        ] + urlpatterns

bootcamp/articles/forms.py
from django import forms

from markdownx.fields import MarkdownxFormField

from bootcamp.articles.models import Article


class ArticleForm(forms.ModelForm):
    status = forms.CharField(widget=forms.HiddenInput())
    edited = forms.BooleanField(
        widget=forms.HiddenInput(), required=False, initial=False)
    content = MarkdownxFormField()

    class Meta:
        model = Article
        fields = ["title", "content", "image", "tags", "status", "edited"]

bootcamp/articles/views.py
from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import CreateView, ListView, UpdateView, DetailView
from django.urls import reverse
from django.utils.translation import ugettext_lazy as _

from bootcamp.helpers import AuthorRequiredMixin
from bootcamp.articles.models import Article
from bootcamp.articles.forms import ArticleForm


class ArticlesListView(LoginRequiredMixin, ListView):
    """Basic ListView implementation to call the published articles list."""
    model = Article
    paginate_by = 15
    context_object_name = "articles"

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context['popular_tags'] = Article.objects.get_counted_tags()
        return context

    def get_queryset(self, **kwargs):
        return Article.objects.get_published()


class DraftsListView(ArticlesListView):
    """Overriding the original implementation to call the drafts articles
    list."""
    def get_queryset(self, **kwargs):
        return Article.objects.get_drafts()


class CreateArticleView(LoginRequiredMixin, CreateView):
    """Basic CreateView implementation to create new articles."""
    model = Article
    message = _("Your article has been created.")
    form_class = ArticleForm
    template_name = 'articles/article_create.html'

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

    def get_success_url(self):
        messages.success(self.request, self.message)
        return reverse('articles:list')


class EditArticleView(LoginRequiredMixin, AuthorRequiredMixin, UpdateView):
    """Basic EditView implementation to edit existing articles."""
    model = Article
    message = _("Your article has been updated.")
    form_class = ArticleForm
    template_name = 'articles/article_update.html'

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

    def get_success_url(self):
        messages.success(self.request, self.message)
        return reverse('articles:list')


class DetailArticleView(LoginRequiredMixin, DetailView):
    """Basic DetailView implementation to call an individual article."""
    model = Article

bootcamp/friendships/views.py
from django.utils import timezone
from django.contrib.auth.decorators import login_required
from django.conf import settings

try:
    from django.contrib.auth import get_user_model

    user_model = get_user_model()
except ImportError:
    from django.contrib.auth.models import User

    user_model = User

from django.shortcuts import render, get_object_or_404, redirect

from .exceptions import AlreadyExistsError
from .models import Friend, Follow, FriendshipRequest, Block

from rest_framework.response import Response
from rest_framework.views import APIView
from rest_framework import generics, status
from django.db.models import F, Q, IntegerField, CharField, ExpressionWrapper, Value
from django.db.models.functions import Least
from django.contrib.gis.db.models.functions import Distance
from bootcamp.users.serializers import UserSerializer, UserListSerializer
from bootcamp.messager.models import MessageThread

from datetime import timedelta
from itertools import chain


class LikeApiView(APIView):

    def get(self, request):
        to_user = get_object_or_404(user_model, id=request.GET['id'])
        from_user = request.user
        if not request.user.add_like():
            return Response(status=status.HTTP_406_NOT_ACCEPTABLE)
        if FriendshipRequest.objects.filter(
            from_user=to_user, to_user=from_user, viewed__isnull=True
        ).exists():
            FriendshipRequest.objects.get(
                from_user=to_user, to_user=from_user).accept()
            return Response(UserSerializer(request.user).data)#"matched"
        try:
            Friend.objects.add_friend(from_user, to_user)
        except AlreadyExistsError:
            #TODO log this error and see why it happens
            f_request = FriendshipRequest.objects.get(from_user=from_user, to_user=to_user)
            if f_request.viewed:
                f_request.rejected = f_request.viewed
                f_request.created = timezone.now()
                f_request.viewed = None
                f_request.save()
                return Response(UserSerializer(request.user).data)#"already_rejected"
            else:
                f_request.created = timezone.now()
                f_request.save()
                return Response(UserSerializer(request.user).data)#"created_updated"
        else:
            FriendshipRequest.objects.filter(from_user=to_user, to_user=from_user, viewed__isnull=False).delete()
            return Response(UserSerializer(request.user).data)#"liked"

    def post(self, request):
        to_user = get_object_or_404(user_model, id=request.POST.get("id", ""))
        from_user = request.user
        if not request.user.add_superlike():
            return Response(status=status.HTTP_406_NOT_ACCEPTABLE)
        if FriendshipRequest.objects.filter(
            from_user=to_user, to_user=from_user, viewed__isnull=True
        ).exists():
            FriendshipRequest.objects.get(
                from_user=to_user, to_user=from_user).accept()
            return Response(UserSerializer(request.user).data)#"matched"
        message = request.POST.get("message", "").strip()
        try:
            if len(message) > 0 and len(message) <= 200:
                Friend.objects.add_friend(from_user, to_user, message)
            else:
                Friend.objects.add_friend(from_user, to_user)
        except AlreadyExistsError:
            #TODO log this error and see why it happens
            f_request = FriendshipRequest.objects.get(from_user=from_user, to_user=to_user)
            if len(message) >= 20 and len(message) <= 200:
                f_request.message = message
            if request.viewed:
                f_request.rejected = f_request.viewed
                f_request.created = timezone.now()
                f_request.viewed = None
                f_request.save()
                return Response(UserSerializer(request.user).data)#"already_rejected"
            else:
                f_request.created = timezone.now()
                f_request.save()
                return Response(UserSerializer(request.user).data)#"created_updated"
        else:
            FriendshipRequest.objects.filter(from_user=to_user, to_user=from_user, viewed__isnull=False).delete()
            return Response(UserSerializer(request.user).data)#"liked"

class PassApiView(APIView):

    def get(self, request):
        to_user = get_object_or_404(user_model, id=request.GET['id'])
        from_user = request.user
        try:
            Friend.objects.add_friend(to_user, from_user)
        except AlreadyExistsError:
            if FriendshipRequest.objects.filter(from_user=to_user, to_user=from_user,
                viewed__isnull=True
            ).exists():
                FriendshipRequest.objects.get(from_user=to_user, to_user=from_user).reject()
                return Response(UserSerializer(request.user).data)#"rejected_or_updated"
            else:
                FriendshipRequest.objects.get(from_user=to_user, to_user=from_user).mark_viewed()
                return Response(UserSerializer(request.user).data)#"viewed_updated"
        else:
            #This is an artificial request created for logging dislike
            #1. when artificial request gets right swipe/ left swipe, handle them
            f_request = FriendshipRequest.objects.get(from_user=to_user, to_user=from_user)
            if FriendshipRequest.objects.filter(from_user=from_user, to_user=to_user,
                viewed__isnull=False
            ).exists():
                FriendshipRequest.objects.get(from_user=from_user, to_user=to_user).delete()
                f_request.reject()
                return Response(UserSerializer(request.user).data)#"both_passed"
            else:
                #delete if any
                FriendshipRequest.objects.filter(from_user=from_user, to_user=to_user).delete()
                f_request.mark_viewed()
                return Response(UserSerializer(request.user).data)#"passed_or_updated"

class ReportApiView(APIView):
    # report fake users
    def get(self, request):
        blocked = get_object_or_404(user_model, id=request.GET['id'])
        blocker = request.user
        try:
            #TODO delete message thread, restrict video calling etc.
            Block.objects.add_block(blocker, blocked, 'P')
        except AlreadyExistsError:
            #TODO log this error and see why it happens
            return Response("already_blocked")
        else:
            return Response("blocked")

    # unmatch
    def post(self, request):
        thread = get_object_or_404(MessageThread, uuid_id=request.POST.get("thread_id", ""))
        reason = request.POST.get("reason", "N")
        if len(reason)>1:
            reason = "N"
        blocker = request.user
        for client in thread.clients.exclude(id=request.user.id):
            try:
                Block.objects.add_block(blocker, client, reason)
            except AlreadyExistsError:
                pass
        thread.is_active = False
        thread.last_activity = timezone.now()
        thread.save()
        return Response("unmatched")

bootcamp/notifications/views.py
from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import get_object_or_404, redirect, render
from django.utils.translation import ugettext_lazy as _
from django.views.generic import ListView

from bootcamp.notifications.models import Notification


class NotificationUnreadListView(LoginRequiredMixin, ListView):
    """Basic ListView implementation to show the unread notifications for
    the actual user"""
    model = Notification
    context_object_name = 'notification_list'
    template_name = 'notifications/notification_list.html'

    def get_queryset(self, **kwargs):
        return self.request.user.notifications.unread()


@login_required
def mark_all_as_read(request):
    """View to call the model method which marks as read all the notifications
    directed to the actual user."""
    request.user.notifications.mark_all_as_read()
    _next = request.GET.get('next')
    messages.add_message(
        request, messages.SUCCESS,
        _(f'All notifications to {request.user.username} have been marked as read.'))

    if _next:
        return redirect(_next)

    return redirect('notifications:unread')


@login_required
def mark_as_read(request, slug=None):
    """View to call the model method which mark as read the provided
    notification."""
    if slug:
        notification = get_object_or_404(Notification, slug=slug)
        notification.mark_as_read()

    messages.add_message(
        request, messages.SUCCESS,
        _(f'The notification {notification.slug} has been marked as read.'))
    _next = request.GET.get('next')

    if _next:
        return redirect(_next)

    return redirect('notifications:unread')


@login_required
def get_latest_notifications(request):
    notifications = request.user.notifications.get_most_recent()
    return render(request,
                  'notifications/most_recent.html',
                  {'notifications': notifications})

bootcamp/templates/users/user_detail.html
{% extends "base.html" %}
{% load static i18n %}
{% load thumbnail %}

{% block title %}{{ object.username }}{% endblock %}

{% block head %}
  <link href="{% static 'css/user_profile.css' %}?v=1" rel="stylesheet">
{% endblock head %}

{% block content %}
  <div class="container">

    {% thumbnail object.picture "x250" as im %}
      <img src="{{ im.url }}" alt="Picture Profile" id="pic">
    {% empty %}
      <img class="pull-right" src="{% static 'img/user.png' %}" height="250px" alt="No Profile Picture" />
    {% endthumbnail %}

    <div id="contact-info" class="vcard">
        <h1 class="fn">
          {{ object.username|title }}
          {% if object.short_bio %}
            <br /><small style="font-size: 50%">{{ object.short_bio }}</small>
          {% endif %}
        </h1>
        <p>
          <i class="fa fa-user-circle-o" aria-hidden="true"></i>
          {{ object.get_profile_name|title }}
          <br />
          <i class="fa fa-envelope" aria-hidden="true"></i><a class="email" href="mailto:{{ object.email }}">   {{ object.email }}</a><br />
          {% if object.job_title %}
            <i class="fa fa-briefcase" aria-hidden="true"></i>  {{ object.job_title }} <br />
          {% endif %}
          {% if object.location %}
            <i class="fa fa-map-marker" aria-hidden="true"></i>  {{ object.location }} <br />
          {% endif %}
        </p>
    </div>
    <div id="objective"><p>{{ object.bio }}</p></div>
    <div class="clear"></div>
    {% if object.personal_url %}
      <a href="{{ object.personal_url }}" style="font-size: 2em" title="{% trans 'RSS Channel' %}"><i class="fa fa-rss"></i>  </a>
    {% endif %}
    {% if object.twitter_account %}
      <a href="{{ object.twitter_account }}" style="font-size: 2em" title="{% trans 'Twitter Profile' %}"><i class="fa fa-twitter"></i>  </a>
    {% endif %}
    {% if object.github_account %}
      <a href="{{ object.github_account }}" style="font-size: 2em" title="{% trans 'Github Profile' %}"><i class="fa fa-github"></i>  </a>
    {% endif %}
    {% if object.linkedin_account %}
      <a href="{{ object.linkedin_account }}" style="font-size: 2em" title="{% trans 'LinkedIn Profile' %}"><i class="fa fa-linkedin"></i>  </a>
    {% endif %}
    {% if object.facebook_account %}
      <a href="{{ object.facebook_account }}" style="font-size: 2em" title="{% trans 'Facebook Profile' %}"><i class="fa fa-facebook"></i>  </a>
    {% endif %}
    <a class="btn btn-dark pull-right" href="{% url 'users:update' %}">{% trans 'Update Profile' %}</a>
  </div>
  {% if request.user.username == object.username %}
    <!-- Data tiles -->
    <div class="row tile_count">
      <div class="col-md-2 col-sm-3 col-xs-4 tile_stats_count">
        <span class="count_top"><i class="glyphicon glyphicon-envelope"></i> {% trans 'Feeds' %}</span>
        <div class="count">0</div>
      </div>
      <div class="col-md-2 col-sm-3 col-xs-4 tile_stats_count">
        <span class="count_top"><i class="glyphicon glyphicon-pencil"></i> {% trans 'Articles' %}</span>
        <div class="count">0</div>
      </div>
      <div class="col-md-2 col-sm-3 col-xs-4 tile_stats_count">
        <span class="count_top"><i class="glyphicon glyphicon-comment"></i> {% trans 'Comments' %}</span>
        <div class="count">0</div>
      </div>
      <div class="col-md-2 col-sm-3 col-xs-4 tile_stats_count">
        <span class="count_top"><i class="glyphicon glyphicon-question-sign"></i> {% trans 'Questions' %}</span>
        <div class="count">0</div>
      </div>
      <div class="col-md-2 col-sm-3 col-xs-4 tile_stats_count">
        <span class="count_top"><i class="glyphicon glyphicon-education"></i> {% trans 'Answers' %}</span>
        <div class="count">0</div>
      </div>
      <div class="col-md-2 col-sm-3 col-xs-4 tile_stats_count">
        <span class="count_top"><i class="glyphicon glyphicon-fire"></i> {% trans 'Global Interactions' %}</span>
        <div class="count">0</div>
      </div>
    </div>
    <!-- /data tiles -->
  {% endif %}
{% endblock content %}

bootcamp/templates/users/user_form.html
{% extends "base.html" %}
{% load static i18n %}
{% load crispy_forms_tags %}
{% load thumbnail %}

{% block title %}{{ user.username|title }}{% endblock %}

{% block head %}
  <link href="{% static 'css/user_form.css' %}?v=1" rel="stylesheet">
{% endblock head %}

{% block content %}

  <div class="row profile">
    <div class="col-md-4 user-profile">
      <h1>{{ user.username|title }}</h1>
      {% if user.name %}<p class="lead">{{ user.name }}</p>{% endif %}
      {% if user.picture %}
        {% thumbnail user.picture "x250" as im %}
          <img src="{{ im.url }}" alt="Picture Profile" id="pic">
        {% endthumbnail %}
      {% else %}
        <img src="{% static 'img/user.png' %}" alt="No Profile Picture" />
      {% endif %}
    </div>

    <div class="col-md-8">
      <form enctype="multipart/form-data" class="form-horizontal" method="post" action="{% url 'users:update' %}">
        {% csrf_token %}
        {{ form|crispy }}
        <div class="control-group">
          <div class="controls">
            <button type="submit" class="btn btn-dark">{% trans 'Update Profile' %}</button>
          </div>
        </div>
      </form>
    </div>
  </div>

{% endblock %}

bootcamp/templates/users/user_list.html
{% extends "base.html" %}
{% load static i18n %}
{% load thumbnail %}
{% block title %}{% trans 'Contacts' %}{% endblock %}

{% block head %}
  <link href="{% static 'css/user_list.css' %}" rel="stylesheet">
{% endblock head %}

{% block content %}

  <div class="page-header">
    <h1>{% trans 'Contacts' %}</h1>
  </div>

  <ul class="user-profiles-list">
    {% for user in user_list %}
      <li>
        <div class="user-avatar">
          <a href="{% url 'users:detail' user.username  %}" class="user-avatar">
            {% thumbnail user.picture "x80" as im %}
              <img src="{{ im.url }}" alt="{% trans 'Picture Profile' %}" id="pic">
            {% empty %}
              <img src="{% static 'img/user.png' %}" height="80px" alt="{% trans 'No Profile Picture' %}" />
            {% endthumbnail %}
          </a>
        </div>
        <p>
          <i class="fa fa-envelope" aria-hidden="true"></i>
          <a class="email" href="mailto:{{ user.email }}">
            {{ user.get_profile_name|title }}
          </a>
          <span>
            {% if user.job_title %}
              <i class="fa fa-briefcase" aria-hidden="true"></i>
              <i>  {{ user.job_title}}</i>
            {% endif %}
          </span>
          <span>
            {% if user.location %}
              <i class="fa fa-map-marker" aria-hidden="true"></i>
              <i>  {{ user.location }}</i>
            {% endif %}
          </span>
        </p>
      </li>
    {% endfor %}
  </ul>

{% endblock content %}